'use strict'

const fs = require('fs')
const path = require('path')
const _ = require('lodash')

const express = require('express')
const router = express.Router()

const prefix = ''

const ROUTERS_PATH = './routers/'

function useRouter (customerRouters, controllerPath) {
  _.each(customerRouters, item => {
    let pid = process.pid
    let method = _.get(item, 'method')
    let uri = _.get(item, 'uri')
    let action = _.get(item, 'action')

    let methods = []

    methods.push(action)

    router[method](prefix + uri, ...methods)

    console.log(`[pid:${pid}]make router succeed. [${method}] [${uri}] [${controllerPath}] [${_.get(action, 'name')}]`)
  })
}

/**
 * read customer routers file recursive
 */
function readAllRouterFile (routersPath = path.resolve(ROUTERS_PATH)) {
  let list = fs.readdirSync(routersPath)

  _.each(list, item => {
    let resolvePath = routersPath + '/' + item
    let stat = fs.statSync(resolvePath)
    let isDir = stat.isDirectory()
    let isFile = stat.isFile()

    if (isDir) {
      readAllRouterFile(resolvePath)
    } else if (isFile) {
      useRouter(require(resolvePath), resolvePath)
    }
  })
}

readAllRouterFile()

router.use(function (req, res) {
  res.status(404).json({'error': 'request address not found.'})
})

module.exports = router
